package NET.worlds.scape;

import NET.worlds.console.Console;

import java.io.IOException;
import java.text.MessageFormat;
import java.util.Enumeration;
import java.util.Vector;

public class ChoiceAction extends Action {
    protected int index = 0;
    Vector actions = new Vector();
    protected Object currentRun = null;
    private static Object classCookie = new Object();

    public ChoiceAction() {
    }

    public Persister trigger(Event var1, Persister var2) {
        if (actions.size() > 0) {
            if (actions.size() >= index) {
                ((Action) actions.get(index)).trigger(var1, var2);
            }
        }
        return null;
    }

    public void addComponent(Action var1) {
        this.actions.addElement(var1);
    }

    public void insertComponent(Action var1, int var2) {
        this.actions.insertElementAt(var1, var2);
    }

    public boolean removeComponent(Action var1) {
        return this.actions.removeElement(var1);
    }

    public Enumeration getComponents() {
        return this.actions.elements();
    }

    public int getIndex() {
        return this.index;
    }

    public void setIndex(int var1) {
        this.index = var1;
    }

    public Object properties(int var1, int var2, int var3, Object var4) throws NoSuchPropertyException {
        Object var5 = null;
        switch (var1 - var2) {
            case 0:
                if (var3 == 0) {
                    var5 = ObjectPropertyAdder.make(new VectorProperty(this, var1, "Components"), this.getRoot(), "NET.worlds.scape.Action");
                } else if (var3 == 1) {
                    var5 = this.actions.clone();
                } else if (var3 == 4) {
                    this.actions.removeElement(var4);
                } else if (var3 == 3) {
                    this.actions.addElement((Action)var4);
                }
                break;
            case 1:
                if (var3 == 0) {
                    var5 = IntegerPropertyEditor.make(new Property(this, var1, "Action Index"));
                } else if (var3 == 1) {
                    var5 = new Integer(this.index);
                } else if (var3 == 2) {
                    this.index = ((Integer)var4).intValue();
                }
                break;
            default:
                var5 = super.properties(var1, var2 + 2, var3, var4);
        }

        return var5;
    }

    public void saveState(Saver var1) throws IOException {
        var1.saveVersion(0, classCookie);
        super.saveState(var1);
        var1.saveInt(this.index);
        var1.saveVector(this.actions);
    }

    public void restoreState(Restorer var1) throws IOException, TooNewException {
        switch (var1.restoreVersion(classCookie)) {
            case 0:
                super.restoreState(var1);
                this.index = var1.restoreInt();
                this.actions = var1.restoreVector();
                break;
            default:
                throw new TooNewException();
        }

    }
}
