package NET.worlds.scape;

import java.io.IOException;

public class SetRandomPoint2Action extends SlidePropertyAction {
    private Point2 _min = new Point2(0,0);
    private Point2 _max = new Point2(100,100);
    private Point2 _value = null;
    private Point2 _start;
    private static Object classCookie = new Object();

    public SetRandomPoint2Action() {
    }

    public Persister trigger(Event var1, Persister var2) {
        SetRandomPoint2Action var3 = null;
        Point2 var4 = null;

        this._value = new Point2(
                (float)((Math.random() * (_max.x - _min.x)) + _min.x),
                (float)((Math.random() * (_max.y - _min.y)) + _min.y)
        );

        if (this.slide()) {
            if (var2 == null) {
                this.start();
                this._start = (Point2)this.get();
            }

            float var13 = this.fraction();
            if ((double)var13 < 1.0) {
                var4 = new Point2(this._value);
                var4.x = (this._value.x - this._start.x) * var13 + this._start.x;
                var4.y = (this._value.y - this._start.y) * var13 + this._start.y;
                var3 = this;
            }
        }

        if (var4 == null) {
            var4 = this._value;
        }

        this.set(var4);
        return var3;
    }

    public Object properties(int var1, int var2, int var3, Object var4) throws NoSuchPropertyException {
        Object var5 = null;
        switch (var1 - var2) {
            case 0:
                if (var3 == 0) {
                    var5 = Point2PropertyEditor.make((new Property(this, var1, "Min")).allowSetNull());
                    if (this._min == null) {
                        var5 = MaybeNullPropertyEditor.make((Property)var5, new Point2());
                    }
                } else if (var3 == 1) {
                    var5 = this._min;
                } else if (var3 == 2) {
                    this._min = (Point2)var4;
                } else if (var3 == 4) {
                    this._min = null;
                }
                break;
            case 1:
                if (var3 == 0) {
                    var5 = Point2PropertyEditor.make((new Property(this, var1, "Max")).allowSetNull());
                    if (this._max == null) {
                        var5 = MaybeNullPropertyEditor.make((Property)var5, new Point2());
                    }
                } else if (var3 == 1) {
                    var5 = this._max;
                } else if (var3 == 2) {
                    this._max = (Point2)var4;
                } else if (var3 == 4) {
                    this._max = null;
                }
                break;
            default:
                var5 = super.properties(var1, var2 + 2, var3, var4);
        }

        return var5;
    }

    public void saveState(Saver var1) throws IOException {
        var1.saveVersion(0, classCookie);
        super.saveState(var1);
        var1.saveMaybeNull(this._min);
        var1.saveMaybeNull(this._max);
    }

    public void restoreState(Restorer var1) throws IOException, TooNewException {
        switch (var1.restoreVersion(classCookie)) {
            case 0:
                super.restoreState(var1);
                this._min = (Point2)var1.restoreMaybeNull();
                this._max = (Point2)var1.restoreMaybeNull();
                return;
            default:
                throw new TooNewException();
        }
    }
}