package NET.worlds.scape;

import NET.worlds.core.Debug;
import java.io.IOException;

public class SetRandomPoint3Action extends SlidePropertyAction {
    private Point3 _min = new Point3(0,0,0);
    private Point3 _max = new Point3(100,100,100);
    private Point3 _value = null;
    private Point3 _start;
    private static Object classCookie = new Object();

    public SetRandomPoint3Action() {
    }

    public Persister trigger(Event var1, Persister var2) {
        SetRandomPoint3Action var3 = null;
        Point3 var4 = null;

        this._value = new Point3(
                (float)((Math.random() * (_max.x - _min.x)) + _min.x),
                (float)((Math.random() * (_max.y - _min.y)) + _min.y),
                (float)((Math.random() * (_max.z - _min.z)) + _min.z)
        );

        if (this.slide()) {
            if (var2 == null) {
                this.start();
                this._start = (Point3)this.get();
            }

            float var13 = this.fraction();
            if ((double)var13 < 1.0) {
                var4 = new Point3(this._value);
                var4.x = (this._value.x - this._start.x) * var13 + this._start.x;
                var4.y = (this._value.y - this._start.y) * var13 + this._start.y;
                var4.z = (this._value.z - this._start.z) * var13 + this._start.z;
                var3 = this;
            }
        }

        if (var4 == null) {
            var4 = this._value;
        }

        this.set(var4);
        return var3;
    }

    public Object properties(int var1, int var2, int var3, Object var4) throws NoSuchPropertyException {
        Object var5 = null;
        switch (var1 - var2) {
            case 0:
                if (var3 == 0) {
                    var5 = Point3PropertyEditor.make((new Property(this, var1, "Min")).allowSetNull());
                    if (this._min == null) {
                        var5 = MaybeNullPropertyEditor.make((Property)var5, new Point3());
                    }
                } else if (var3 == 1) {
                    var5 = this._min;
                } else if (var3 == 2) {
                    this._min = (Point3)var4;
                } else if (var3 == 4) {
                    this._min = null;
                }
                break;
            case 1:
                if (var3 == 0) {
                    var5 = Point3PropertyEditor.make((new Property(this, var1, "Max")).allowSetNull());
                    if (this._max == null) {
                        var5 = MaybeNullPropertyEditor.make((Property)var5, new Point3());
                    }
                } else if (var3 == 1) {
                    var5 = this._max;
                } else if (var3 == 2) {
                    this._max = (Point3)var4;
                } else if (var3 == 4) {
                    this._max = null;
                }
                break;
            default:
                var5 = super.properties(var1, var2 + 1, var3, var4);
        }

        return var5;
    }

    public void saveState(Saver var1) throws IOException {
        var1.saveVersion(0, classCookie);
        super.saveState(var1);
        var1.saveMaybeNull(this._min);
        var1.saveMaybeNull(this._max);
    }

    public void restoreState(Restorer var1) throws IOException, TooNewException {
        switch (var1.restoreVersion(classCookie)) {
            case 0:
                super.restoreState(var1);
                this._min = (Point3)var1.restoreMaybeNull();
                this._max = (Point3)var1.restoreMaybeNull();
                return;
            default:
                throw new TooNewException();
        }
    }
}